/**
 * 
 */
package traders;

import sim.engine.SimState;
import simulations.WineSimulation;

/**
 * @author
 *
 */
public class SimpleTrader extends BaseTrader {

	/**
	 * 
	 */
	private static final long serialVersionUID = -1004455120969700802L;

	/**
	 * 
	 */
	public SimpleTrader(int id, boolean isBuyer, double value, double provision ) {
		this.id = id;
		this.buyValue = value;
		this.buyPrice = value / (1+provision);
		this.sellValue = value;
		this.sellPrice = value / (1-provision);
		if(isBuyer){
			this.hasWine = false;
			this.winesNumber = 0;	
		} else {
			this.hasWine = true;
			this.winesNumber = 1;
		}
		this.isStillActive = true;
	}
	
	public SimpleTrader(int id, boolean isBuyer, double value, double buyProvision, double sellProvision)  {
		this.id = id;
		this.buyValue = value;
		this.buyPrice = value / (1+buyProvision);
		this.sellValue = value;
		this.sellPrice = value / (1-sellProvision);
		if(isBuyer){
			this.hasWine = false;
			this.winesNumber = 0;	
		} else {
			this.hasWine = true;
			this.winesNumber = 1;
		}
		this.isStillActive = true;
	}

	
	/* (non-Javadoc)
	 * @see sim.engine.Steppable#step(sim.engine.SimState)
	 */
	@Override
	public void step(SimState simState) {
		WineSimulation simulation = (WineSimulation) simState;
		if(this.isStillActive){ //only if it is still active
			if(hasWine){ //tries to deactivate (drinking)
				if(simulation.randomInactivate.nextDouble()<simulation.lambdaInactivation){
					this.isStillActive = false;
				} else {
					if(tradingMechanism.isTrading(this)){
						if(simulation.randomWithdraw.nextDouble()<simulation.lambdaRemoveOrder){
							tradingMechanism.withdrawOrder(this);	
						}
					} else {
						if(simulation.randomPlace.nextDouble()<simulation.lambdaPlaceOrder){//place an order
							trySelling();
						}
					}
				}
			} else { //does not have wine 
				if(tradingMechanism.isTrading(this)){
					if(simulation.randomWithdraw.nextDouble()<simulation.lambdaRemoveOrder){
						tradingMechanism.withdrawOrder(this);	
					}
				} else {
					if(simulation.randomPlace.nextDouble()<simulation.lambdaPlaceOrder){//place an order
						tryBuying();
					}
				}
			}	
		}
	}
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

}
